import { StyleSheet, Text, View, ScrollView, Alert, Dimensions } from 'react-native';
import ExpoWebView from 'sitepal-react-native-v2';
import  Buttons  from './components/Buttons.js';
import React, { Component , useState, useEffect} from 'react';

export default function App() {

  const [sayText, setSayText] = useState(undefined)
  const [sayAudio, setSayAudio] = useState(undefined)
  const [loadSceneByID, setLoadSceneByID] = useState(undefined)
  const [myText, setMyText] = useState('')
  
  // Replace embed string with an embed string from your SitePal account
  //       To do so, select the 'publish' option for the Scene you wish to embed here (for Full Body - select 'inline' embed option)
  //	   In your embed code - copy the entire parameter string from the embed function, and replace the below string with your own.
  const embed = 'XXXXXXX,600,800,"",1,1,YYYYYYY,0,1,1,ZZZZZZZ,0';

  const sayAudioFn = () => {
    // var date = new Date().getTime()
    // alert(date.toString)
    setSayAudio(["sayAudioExample"]);
  }
  const sayTextFn = () => {
        setSayText(['Welcome to our text to speech API example',3,1,3]);
  }
  const loadSceneByIDFn2D = () => {
        setLoadSceneByID([AAAAAAA]);    // Replace 'AAAAAAA' with the ID of the Scene you want to load
        setMyText("")
  }
  const loadSceneByIDFn3D = () => {
    setLoadSceneByID([BBBBBBB]);		// Replace 'BBBBBBB' with the ID of the Scene you want to load
    setMyText("")
  }
  const loadSceneByIDFnFull = () => {
    setLoadSceneByID([CCCCCCC]);		// Replace 'CCCCCCC' with the ID of the Scene you want to load
    setMyText("")
  }
  const setCallbackOutput = (response) => {
    setMyText(myText+response+'\n');
  }
  const callBacks = () => {
    return `
         function vh_sceneLoaded(){
          window.setStatus(0,1,0,1);
            window.ReactNativeWebView.postMessage("Received 'vh_sceneLoaded' event   calling: 'setStatus(0,1,0,1)' ");
           }
           function vh_audioEnded(){
              window.ReactNativeWebView.postMessage("Received 'vh_audioEnded' event");
            }
           function vh_ttsLoaded(){
            }
           function vh_talkStarted(){
            }
           function vh_talkEnded(){
               window.ReactNativeWebView.postMessage("Received 'vh_audioProgress' at " + percentPlayed + "%");
            }
             function vh_audioProgress(percentPlayed) {
              window.ReactNativeWebView.postMessage("Received 'vh_audioProgress' at " + percentPlayed + "%");
            }
            // function vh_apiFunctionCallback(method)
            // {
            //   window.ReactNativeWebView.postMessage("called method'  " + method + "");
            // }
    `;
  }

  return (
    <View style={styles.container}>
       <ScrollView style={{marginVertical: 20}}>
          <View style={{justifyContent: 'center',marginTop:-40}}>
          <ExpoWebView embed={embed} loadSceneByID={loadSceneByID} sayAudio={sayAudio} sayText={sayText} setCallbackOutput={setCallbackOutput} callBacks={callBacks}/> 

            <ScrollView style={{
              marginTop:-200,
                borderWidth: 1,
                alignSelf:"center",
                width:300,
                height:Dimensions.get('window').height*0.25,
                marginBottom:10}}>
              <Text style={{color: 'black'}}>
              {myText}
              </Text>              
            </ScrollView>          
            <Buttons loadSceneByIDFn2D={loadSceneByIDFn2D} loadSceneByIDFn3D={loadSceneByIDFn3D} loadSceneByIDFnFull={loadSceneByIDFnFull} sayAudioFn={sayAudioFn} sayTextFn={sayTextFn}/> 
          </View>
      </ScrollView>
    </View>
  );
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: '#fff',
    alignItems: 'center',
    border: '1px solid',
  },
  scroller:{
    flexGrow: 0.4,
    marginTop: 10,
    borderWidth: 1,
    width:300,
    height:100,
    marginBottom:10,
    margin:'auto'
  },
  input: {
    marginTop: 10,
    borderWidth: 1,
    width:300,
    height:200,
    marginBottom:10,
    margin:'auto'
  },
});
